import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class player1 extends Actor
{
    /**
     * Act - do whatever the player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    //Анимации
    GifImage idle = new GifImage("player1/idle.gif");
    GifImage idleF = new GifImage("player1/idleF.gif");
    GifImage run = new GifImage("player1/run.gif");
    GifImage runF = new GifImage("player1/runF.gif");
    
    //Вектора направления движения
    int vecX = 0;int vecY = 0;
    //Коллизия
    boolean up = false; boolean down = false; boolean left = false; boolean right = false;
    //Отразить ли анимацию
    boolean fliped = false;
    
    public static int score = 0;
    int scoreX = 50; int scoreY = 30;
    int locX; int locY;
    
    public void addedToWorld(World MyWorld){
        getWorld().showText(""+score, scoreX, scoreY);
    }
    
    public void act()
    {
        if(!isTouching(collision.class)){
            control();}
        collisions();
        loot();    
    }
    
    //Управление игрока
    void control(){
        //Если нажата какая-то кнопка, то меняем направление и отражаем картинку если нужно
        if(Greenfoot.isKeyDown("left") ){
            vecX = -3;    
            fliped = true;
        }
        
        if(Greenfoot.isKeyDown("right") ){
            vecX = 3;   
            fliped = false;
        }
        
        if(Greenfoot.isKeyDown("up") ){
            vecY=-3;
        }
        
        if(Greenfoot.isKeyDown("down") ){
            vecY=3;
        }
        
        //Применяем анимации
        if(vecX != 0 || vecY != 0){
            if(fliped){setImage(runF.getCurrentImage());}    
            else{setImage(run.getCurrentImage());}
        }
        else { 
            if(fliped){setImage(idleF.getCurrentImage());}    
            else{setImage(idle.getCurrentImage());}
        }
        //двигаем
        setLocation(getX()+vecX, getY()+vecY);
        //Сбрасываем скорость
        vecX = 0; vecY = 0;
    }

    //Обработка коллизии
    void collisions(){
        if(isTouching(collision.class)){
                
                if(side() == 1){
                    setLocation(getX() - 3 , getY());
                }
                if(side() == 2){
                    setLocation(getX() + 3 , getY());    
                }
                if(side() == 3){
                    setLocation(getX() , getY() + 3);    
                }
                if(side() == 4){
                    setLocation(getX() , getY() - 3);    
                }
                
                
                
        }
        
    
    }
    
    void loot(){
        if(isTouching(loot.class)){
            score++;
            removeTouching(loot.class);
            getWorld().showText(""+score, scoreX, scoreY);
        }    
    }
    
    int side(){
    
        int s = 0;
        if(isTouching(collision.class)){
            Actor wall = getOneIntersectingObject(collision.class);
            int H = wall.getImage().getHeight(); //Высота
            int W = wall.getImage().getWidth(); //Ширина
            
            int X = wall.getX();
            int Y = wall.getY();
            if(getX()<X ){
                s = 1;
                
            }
            if(getX()>X ){
                s = 2;
                
            }
            if(getY()>Y && getX() > X - W/2 && getX() < X + W/2 ){
                s = 3;
                
            }
            if(getY()<Y && getX() > X - W/2 && getX() < X + W/2 ){
                s = 4;
                
            }
        }
        return s;

    }
}
