import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class player2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class player2Old extends Actor
{
    /**
     * Act - do whatever the player2 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    //Анимации
    GifImage idle = new GifImage("player2/idle.gif");
    GifImage idleF = new GifImage("player2/idleF.gif");
    GifImage run = new GifImage("player2/run.gif");
    GifImage runF = new GifImage("player2/runF.gif");
    
    //Вектора направления движения
    int vecX = 0;int vecY = 0;
    //Коллизия
    boolean up = true; boolean down = true; boolean left = true; boolean right = true;
    //Отразить ли анимацию
    boolean fliped = false;
    int score = 0;
    int scoreX = 610; int scoreY = 30;
    
    
    public void addedToWorld(World MyWorld){
        getWorld().showText(""+score, scoreX, scoreY);
    }
    
    public void act()
    {
        control();
        collisions();
        loot();
    }
    
    //Управление игрока
    void control(){
        //Если нажата какая-то кнопка, то меняем направление и отражаем картинку если нужно
        if((Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("ф")) && left){
            vecX = -3;    
            fliped = true;
        }
        
        if((Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("в")) && right){
            vecX = 3;   
            fliped = false;
        }
        
        if((Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("ц")) && up){
            vecY=-3;
        }
        
        if((Greenfoot.isKeyDown("s") || Greenfoot.isKeyDown("ы") ) && down){
            vecY=3;
        }
        
        //Применяем анимации
        if(vecX != 0 || vecY != 0){
            if(fliped){setImage(runF.getCurrentImage());}    
            else{setImage(run.getCurrentImage());}
        }
        else { 
            if(fliped){setImage(idleF.getCurrentImage());}    
            else{setImage(idle.getCurrentImage());}
        }
        //двигаем
        setLocation(getX()+vecX, getY()+vecY);
        //Сбрасываем скорость
        vecX = 0; vecY = 0;
    }

    //Обработка коллизии
    void collisions(){
        if(isTouching(collision.class)){
            int touchX = getNeighbours(100, true, collision.class).get(0).getX();
            int touchY = getNeighbours(100, true, collision.class).get(0).getY();
            //Размер одного квадрата коллизии
            int size = 32;
    
            if(getX()<touchX-size){
                right = false;    
            }
            
            if(getX()>touchX+size){
                left = false;    
            }
            
            if(getY()<touchY-size){
                down = false;    
            }
            
            if(getY()>touchY+size){
                up = false;    
            }
            
            //Обработка столкновений в углах
            if(getX()<touchX-size && (getY()>touchY+size || getY()<touchY-size)){
                right = true;
            }
            
            if(getX()>touchX+size && (getY()>touchY+size || getY()<touchY-size)){
                left = true;
            }
        }
        if(!isTouching(collision.class)){
            left = true;
            right = true;
            up = true;
            down = true;
        }
    }
     
    void loot(){
        if(isTouching(loot.class)){
            score++;
            removeTouching(loot.class);
            getWorld().showText(""+score, scoreX, scoreY);

        }    
    }
}
